/****************************************Copyright (c)*************************
**                               Ȩ (C), 2015-2020, ͿѻƼ
**
**                                 http://www.tuya.com
**
**--------------ļϢ-------------------------------------------------------
**      : main.c
**        : 
**ʹ  ˵  : 
**
**
**--------------ǰ汾޶---------------------------------------------------

**   : v2.0
** ա: 2016329
** 衡: 1:Żṹ
**
**-----------------------------------------------------------------------------
******************************************************************************/
#define MAIN_GLOBAL
#include "include.h"

#include "wifi.h"


TYPE_BUFFER_S FlashBuffer;


volatile uint8_t is_read_time = 0;
uint8_t read_pm25 = 0;

//==============================================================================
//Ͷ
//λ
//==============================================================================
#define         FALUT_TMPER_SUPERHEAT                 0x01                      //¶ȹ
#define         FALUT_TMPER_UNEXIST                   0x02                      //ʪȴ
#define         FALUT_PM25_UNEXIST                    0x04                      //PM2.5

/*****************************************************************************
 : Reset
 : ϵͳλ
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
void Reset(void)
{
  NVIC_SystemReset();
}
/*****************************************************************************
 : NVIC_Configuration
 : NVIC
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
static void NVIC_Configuration(void)
{
#ifdef ENABLE_BOOT
  NVIC_SetVectorTable(NVIC_VectTab_FLASH,OFFSET_FIRMWARE_L);
#else
  NVIC_SetVectorTable(NVIC_VectTab_FLASH,0);
#endif
  
  //Configure the NVIC Preemption Priority Bits
  NVIC_PriorityGroupConfig(NVIC_PriorityGroup_0);
}
/*****************************************************************************
 : RCC_Configuration
 : ʱ
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
static void RCC_Configuration(void)
{
  //DMAʱ 
  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, (FunctionalState)ENABLE);  
  
  //Enable AFIO clocks
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, (FunctionalState)ENABLE);
  
  //ʹJTAGΪGPIO  
  GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable, (FunctionalState)ENABLE);
}
/*****************************************************************************
 : Bsp_Init
 : ʼ
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
static void Bsp_Init(void)
{
  RCC_Configuration();
  NVIC_Configuration();

  USART1_Init(9600);
  USART3_Init(9600);
  //
  TIM2_Count_Init();
  TIM3_Count_Init(99,719);//1ms
  //
  TIM4_Count_Init();
  //
  KEY_Init();
  RGB_LED_Init();
  Delay_Init(72);
  DHT11_Init();
}
/*****************************************************************************
 : wifi_work_state_led
 : wifi״̬led
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
static void wifi_work_state_led(void)
{
    uint8_t wifi_state = mcu_get_wifi_work_state();

    switch(wifi_state)
    {
    case SMART_CONFIG_STATE:
      if(Get_Time3_Value() % 2 == 0)
      {
        LED_Control(LED1,1);
      }
      else
      {
        LED_Control(LED1,0);
      }
      break;
      
    case AP_STATE:
      if(Get_Time3_Value() == 0)
      {
        LED_Control(LED1,1);
      }
      else if(Get_Time3_Value() == 6)
      {
        LED_Control(LED1,0);
      }
      break;
      
    case WIFI_NOT_CONNECTED:
        LED_Control(LED1,0);
      break;
      
    case WIFI_CONNECTED:
      LED_Control(LED1,1);
      break;
      
    default:
      LED_Control(LED1,0);
      break;
    }
}
/*****************************************************************************
 : get_pm25_checksum
 : PM2.5У
 : addr:ʼָ/len:
ز : sum:У
ʹ˵ : 
*****************************************************************************/
static uint8_t get_pm25_checksum(uint8_t *addr,uint8_t len)
{
  uint8_t sum = 0;
  
  while(len --)
  {
    sum += *addr ++;
  }
  
  return sum;
}
/*****************************************************************************
 : pm25_value_ctl
 : PM2.5ݴ
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
static void pm25_value_ctl(void)
{
  #define         PM25_DATA_LEN           10
  extern uint8_t pm25_buffer[];
  extern uint16_t uart_input_count;
  uint8_t pm25_value[16];
  uint8_t rx_in = 0;
  uint8_t offset = 0;
  
  //copy
  memcpy(pm25_value, pm25_buffer, uart_input_count);
  rx_in = uart_input_count;
  uart_input_count = 0;

  //
  if(rx_in < PM25_DATA_LEN)
  {
    return;
  }
  
  while((rx_in - offset) >= PM25_DATA_LEN)
  {
    if(pm25_value[offset] != 0xaa)
    {
      offset ++;
      continue;
    }
    
    if(pm25_value[offset + 1] != 0xc0)
    {
      offset ++;
      continue;
    }
    
    if(pm25_value[offset + 8] != get_pm25_checksum(pm25_value + offset + 2,6))
    {
      offset += 2;
      continue;
    }
    
    FlashBuffer.pm_25 = (pm25_value[offset + 3] * 0x100 + pm25_value[offset + 2]) / 10;
    
    offset += PM25_DATA_LEN;
    read_pm25 = 1;
  }
}
/*****************************************************************************
 : get_pm25
 : ȡPM2.5
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
static void get_pm25(void)
{
  if(read_pm25 == 1)
  {
    //ɹ
    mcu_dp_value_update(DPID_PM25,FlashBuffer.pm_25);     //VALUEϱ;
  }
  else if(read_pm25 == 0)       
  {
    //ʧ
    FlashBuffer.falut |= FALUT_PM25_UNEXIST;
    mcu_dp_fault_update(DPID_FAULT,FlashBuffer.falut); //ϱ;
  }
}
/*****************************************************************************
 : get_tvoc
 : ȡtvoc
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
static void get_tvoc(void)
{
  /*
  ʾδʵTVOCȡ,ûʵ
  */
  FlashBuffer.tvoc = 100;
  
  mcu_dp_value_update(DPID_TVOC,FlashBuffer.tvoc);      //VALUEϱ;
}
/*****************************************************************************
 : get_filter
 : ȡоٷֱ
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
static void get_filter(void)
{
  /*
  ʾδʵоٷֱͳ,ûʵ
  */
  FlashBuffer.filter = 100;
  
  mcu_dp_value_update(DPID_FILTER,FlashBuffer.filter); //VALUEϱ;
}
/*****************************************************************************
 : get_runtime
 : ȡʱͳ
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
static void get_runtime(void)
{
  mcu_dp_value_update(DPID_TOTALTIME,FlashBuffer.run_time); //VALUEϱ;
}
/*****************************************************************************
 : get_temper_humidity
 : ȡʪ
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
static void get_temper_humidity(void)
{
  uint8_t state;
  uint8_t temperature,humidity;
  
  state = DHT11_Read_Data(&temperature,&humidity);
  
  if(state == 0)
  {
    //¶ͷȡ
    FlashBuffer.temper = temperature;
    FlashBuffer.humidity = humidity;
    
    mcu_dp_value_update(DPID_HUMIDITY,FlashBuffer.humidity); //VALUEϱ;  
    if(FlashBuffer.temper <= 50)
    {
      FlashBuffer.falut = 0;
      //¶ϱ
      mcu_dp_value_update(DPID_TEMP,FlashBuffer.temper); //VALUEϱ;
    }
    else
    {
      //,¶ȹ
      FlashBuffer.falut &= ~FALUT_TMPER_UNEXIST;
      FlashBuffer.falut |= FALUT_TMPER_SUPERHEAT;
      mcu_dp_fault_update(DPID_FAULT,FlashBuffer.falut); //ϱ;
    }
  }
  else
  {
    //,¶ͷδ⵽
    FlashBuffer.falut &= ~FALUT_TMPER_SUPERHEAT;
    FlashBuffer.falut |= FALUT_TMPER_UNEXIST;
    mcu_dp_fault_update(DPID_FAULT,FlashBuffer.falut); //ϱ;
  }
}
/*****************************************************************************
 : read_sensor
 : ȡ
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
static void read_sensor(void)
{
  get_temper_humidity();                                                    //ȡʪ
  get_pm25();                                                               //ȡPM2.5
  get_runtime();                                                            //ȡʱ
  get_filter();                                                             //ȡоʹ
  get_tvoc();                                                               //ȡTVOC
}
/*****************************************************************************
 : read_parameter
 : ȡ
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
static void read_parameter(void)
{
  Read_Flash((unsigned char *)&FlashBuffer,PARA_ADDR,sizeof(FlashBuffer));

  if((FlashBuffer.magic_code != 0) && (FlashBuffer.magic_code != 0xffffffff))
  {
    memset(&FlashBuffer,0,sizeof(FlashBuffer));
    
    Earse_Flash(PARA_ADDR);
    if(Write_Flash(PARA_ADDR,(unsigned char *)&FlashBuffer,sizeof(FlashBuffer)) == ERROR)
    {
      
    }
  }  
}
/*****************************************************************************
 : main
 : 
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
void main(void)
{
  extern uint8_t uart_input_finish;
  extern uint16_t uart_input_count;
  
  Bsp_Init();
  //ȡ
  read_parameter();
  
  //wifiʼ  
  wifi_protocol_init();

  //ȡϱ
  read_sensor();
  FlashBuffer.falut = 0;
  FlashBuffer.power_switch = 0;

  while(1)
  {
    wifi_uart_service();
    
    Key_Scan();
    wifi_work_state_led();
    
    if(uart_input_finish == 1)
    {
      USART_Cmd(USART1, (FunctionalState)DISABLE);

      //PM2.5
      pm25_value_ctl();
      uart_input_finish = 0;

      USART_Cmd(USART1, (FunctionalState)ENABLE);
    }
    
    if(is_read_time == 1)                                                       //15ȡһ
    {
      //ȡϱ
      read_sensor();                                 
      /*
      ÿ15ȡʱ,УԱRTC
      protocol.cmcu_write_rtctime()ɣңԣд
      */
      mcu_get_system_time();
      //
      is_read_time = 0;
    }
  }
}
